package org.netkernel.module.standard.builtin;

import org.netkernel.layer0.meta.IPrototypeParameterMeta;
import org.netkernel.layer0.meta.impl.DefaultPrototypeMeta;
import org.netkernel.layer0.meta.impl.PrototypeParameterMetaImpl;
import org.netkernel.module.standard.endpoint.IStandardOverlay;
import org.netkernel.urii.IIdentifier;

public class PluggableOverlayPrototype extends DefaultPrototypeMeta
{
	public static final String POST_PROCESS_CONFIG="postProcess";
	public static final String PRE_PROCESS_CONFIG="preProcess";
	public static final String EX_PROCESS_CONFIG="exceptionProcess";
	
	public static IPrototypeParameterMeta[] sPrototypeParameters = new IPrototypeParameterMeta[]
    {	IStandardOverlay.sPrototypeParameters[0], //space
		new PrototypeParameterMetaImpl(PRE_PROCESS_CONFIG,IIdentifier.class,null),
		new PrototypeParameterMetaImpl(POST_PROCESS_CONFIG,IIdentifier.class,null),
		new PrototypeParameterMetaImpl(EX_PROCESS_CONFIG,IIdentifier.class,null),
  	};
	
	public PluggableOverlayPrototype()
	{	super(PluggableOverlay.class,"PluggableOverlay");
	}

	public IPrototypeParameterMeta[] getParameters()
	{	return sPrototypeParameters;
	}

	public String getDescription()
	{	return "allows a pluggable endpoint for pre and post processing";
	}

	public String getName()
	{	return "Pluggable Overlay";
	}
}
