/******************************************************************************
  (c) Copyright 2002-2008, 1060 Research Ltd                                   

  This Software is licensed to You, the licensee, for use under the terms of   
  the 1060 Public License v1.0. Please read and agree to the 1060 Public       
  License v1.0 [www.1060research.com/license] before using or redistributing   
  this software.                                                               

  In summary the 1060 Public license has the following conditions.             
  A. You may use the Software free of charge provided you agree to the terms   
  laid out in the 1060 Public License v1.0                                     
  B. You are only permitted to use the Software with components or applications
  that provide you with OSI Certified Open Source Code [www.opensource.org], or
  for which licensing has been approved by 1060 Research Limited.              
  You may write your own software for execution by this Software provided any  
  distribution of your software with this Software complies with terms set out 
  in section 2 of the 1060 Public License v1.0                                 
  C. You may redistribute the Software provided you comply with the terms of   
  the 1060 Public License v1.0 and that no warranty is implied or given.       
  D. If you find you are unable to comply with this license you may seek to    
  obtain an alternative license from 1060 Research Limited by contacting       
  license@1060research.com or by visiting www.1060research.com                 

  NO WARRANTY:  THIS SOFTWARE IS NOT COVERED BY ANY WARRANTY. SEE 1060 PUBLIC  
  LICENSE V1.0 FOR DETAILS                                                     

  THIS COPYRIGHT NOTICE IS *NOT* THE 1060 PUBLIC LICENSE v1.0. PLEASE READ     
  THE DISTRIBUTED 1060_Public_License.txt OR www.1060research.com/license      

  File:          $RCSfile: StandardTransreptorImpl.java,v $
  Version:       $Name:  $ $Revision: 1.8 $
  Last Modified: $Date: 2008/05/14 15:36:40 $
 *****************************************************************************/

package org.netkernel.module.standard.endpoint;


import org.netkernel.container.IKernel;
import org.netkernel.layer0.meta.impl.*;
import org.netkernel.layer0.nkf.*;
import org.netkernel.layer0.util.Utils;
import org.netkernel.urii.*;

/**
 * Base Class for Standard Module Transreptors.
 * @author  pjr
 */
public abstract class StandardTransreptorImpl extends StandardMonoEndpointImpl
{
	private TransreptorMetaBuilder2 mMetaBuilder;
	
	/** Creates a new instance of StandardAccessorImpl */
	public StandardTransreptorImpl()
	{	mMetaBuilder=new TransreptorMetaBuilder2();
		mMetaBuilder.setName(Utils.shortClassName(this.getClass()));
	}
	
	public void declareName(String aName)
	{	mMetaBuilder.setName(aName);
	}
	
	public void declareDescription(String aDescription)
	{	mMetaBuilder.setDescription(aDescription);
	}	

	public void declareFromRepresentation(Class aRepresentation)
	{	mMetaBuilder.addFromRepresentation(aRepresentation);
	}
	
	public void declareToRepresentation(Class aRepresentation)
	{	mMetaBuilder.addResponseClass(aRepresentation);
	}
	
	public void onCommissionEndpoint(IKernel aKernel, ISpace aSpace) throws Exception
	{	super.onCommissionEndpoint(aKernel, aSpace);
			
		if (getParameters().paramExists(StandardMonoEndpointImpl.PARAM_NAME))
		{	String s=(String)getParameters().getParamValue(StandardMonoEndpointImpl.PARAM_NAME);
			if  (s!=null)
			{	declareName(s);
			}
		}
		if (getParameters().paramExists(StandardMonoEndpointImpl.PARAM_DESCRIPTION))
		{	String s=(String)getParameters().getParamValue(StandardMonoEndpointImpl.PARAM_DESCRIPTION);
			if  (s!=null)
			{	declareDescription(s);
			}
		}
		if (getParameters().paramExists(StandardMonoEndpointImpl.PARAM_DOC))
		{	IIdentifier id=(IIdentifier)getParameters().getParamValue(StandardMonoEndpointImpl.PARAM_DOC);
			if  (id!=null)
			{	mMetaBuilder.setHumanReadableDocumentation(id);
			}
		}
		if (getParameters().paramExists(StandardMonoEndpointImpl.PARAM_ICON))
		{	IIdentifier id=(IIdentifier)getParameters().getParamValue(StandardMonoEndpointImpl.PARAM_ICON);
			if  (id!=null)
			{	mMetaBuilder.setIcon(id);
			}
		}
	
		mMeta=mMetaBuilder.getMeta(aKernel.getLogger());
		mMetaBuilder=null;
	}
	
	/** Implement this method to provide the resultant representation on the response
	 * @param aContext the full NKF context for the request
	 * @exception Exception you can throw any exception you like and it will be mapped
	 * into a NetKernelException
	 */
	public abstract void onTransrept(INKFRequestContext context) throws Exception;
	
}
